#ifndef STL_QUEUE_WRAPPER_H
#define STL_QUEUE_WRAPPER_H

#include <cassert>
#include <queue>

#include "queue.h"

namespace seq
{
   class STLQueueWrapper: public Queue
   {
    public:
      bool empty() const override { return this->container.empty(); } 

      void clear() override { this->container = std::queue<int>(); }
      
      void enqueue(int pushed_item) override { this->container.push(pushed_item); }
      
      int dequeue() override { int out = this->container.front(); this->container.pop(); return out; }

    private:
      std::queue<int> container;
   };
}

#endif
